#ifndef IOHB_H
#define IOHB_H

#include<stdio.h>
#include<stdlib.h>
#include<malloc.h>
#ifdef __cplusplus
extern "C" {
#endif

/* User-callable functions: */
void readHB_info(const char*, int*, int*, int*, char **, int*);
void readHB_mat_double(const char*, int*, int*, double*);
void readHB_newmat_double(const char*, int*, int*, int*, int**, int**, double**);
void readHB_mat_float(const char*, int*, int*, float*);
void readHB_newmat_float(const char*, int*, int*, int*, int**, int**, float**);
void readHB_rhs_double(const char*, double*, int);
void readHB_newrhs_double(const char*, double**, int);
void readHB_rhs_float(const char*, float*, int);
void readHB_newrhs_float(const char*, float**, int);
void writeHB_mat_double(const char*, int, int, int, const int*, const int*, 
              const double*, int, const double*, const char*, const char*, const char*);
void writeHB_mat_float(const char*, int, int, int, const int*, const int*, 
              const float*, int, const float*, const char*, const char*, const char*);
void writetxt_mat_double(const char*, int, int, int, const int*, const int*, 
              const double*, const char*, const char*, const char*);
void writetxt_mat_float(const char*, int, int, int, const int*, const int*, 
              const float*, const char*, const char*, const char*);
 
#ifdef __cplusplus
}
#endif

#endif
