void ScaleArray_double(int m, int n, double *c, int ldc, const double beta)
{
  /* C <- beta*C         */
  /* C is m x n          */
  /* beta is a scalar    */

  int i, j;

  if (beta == 1.0)
    return;

  if (beta == 0.0) {
    if (n == 1)
      for (j = 0; j < m; j++)
	c[j] = 0.0;
    else
      for (i = 0; i < n; i++)
	for (j = 0; j < m; j++)
	  c[ldc*i+j] = 0.0;
  } else {
    if (n == 1)
      for (j = 0; j < m; j++)
	c[j] *= beta;
    else
      for (i = 0; i < n; i++)
	for (j = 0; j < m; j++)
	  c[ldc*i+j] *= beta;
  }
}

/*-----------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------*/

void ScaleArray_float(int m, int n, float *c, int ldc, const float beta)
{
  /* C <- beta*C          */
  /* C is m x n           */
  /* beta is a scalar     */

  int i, j;

  if (beta == 1.0)
    return;

  if (beta == 0.0) {
    if (n == 1)
      for (j = 0; j < m; j++)
	c[j] = 0.0;
    else
      for (i = 0; i < n; i++)
	for (j = 0; j < m; j++)
	  c[ldc*i+j] = 0.0;
  } else {
    if (n == 1)
      for (j = 0; j < m; j++)
	c[j] *= beta;
    else
      for (i = 0; i < n; i++)
	for (j = 0; j < m; j++)
	  c[ldc*i+j] *= beta;
  }
}
